diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDeadBush.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDeadBush.java
similarity index 81%
rename from src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDeadBush.java
rename to game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDeadBush.java
index cdf7e68df..06485a40d 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDeadBush.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureDeadBush.java
@@ -2,6 +2,7 @@ package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.BlockLeavesBase;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
@@ -18,13 +19,13 @@ public class WorldFeatureDeadBush extends WorldFeature
     @Override
 	public boolean place(World world, Random random, int x, int y, int z)
     {
-        for(int l; ((l = world.getBlockId(x, y, z)) == 0 || Block.blocksList[l] instanceof BlockLeavesBase) && y > 0; y--) { }
+        for(int l; ((l = world.getBlockId(x, y, z)) == 0 || Blocks.blocksList[l] instanceof BlockLeavesBase) && y > 0; y--) { }
         for(int i1 = 0; i1 < 4; i1++)
         {
             int j1 = (x + random.nextInt(8)) - random.nextInt(8);
             int k1 = (y + random.nextInt(4)) - random.nextInt(4);
             int l1 = (z + random.nextInt(8)) - random.nextInt(8);
-            if(world.isAirBlock(j1, k1, l1) && Block.blocksList[blockId].canBlockStay(world, j1, k1, l1))
+            if(world.isAirBlock(j1, k1, l1) && Blocks.blocksList[blockId].canBlockStay(world, j1, k1, l1))
             {
                 world.setBlock(j1, k1, l1, blockId);
             }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFlowers.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFlowers.java
similarity index 89%
rename from src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFlowers.java
rename to game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFlowers.java
index aaab501e6..438e8196f 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFlowers.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureFlowers.java
@@ -2,6 +2,7 @@ package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockFlowerStackable;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
@@ -28,10 +29,10 @@ public class WorldFeatureFlowers extends WorldFeature
             int i1 = (x + random.nextInt(8)) - random.nextInt(8);
             int j1 = (y + random.nextInt(4)) - random.nextInt(4);
             int k1 = (z + random.nextInt(8)) - random.nextInt(8);
-            if(world.isAirBlock(i1, j1, k1) && Block.blocksList[plantBlockId].canBlockStay(world, i1, j1, k1))
+            if(world.isAirBlock(i1, j1, k1) && Blocks.blocksList[plantBlockId].canBlockStay(world, i1, j1, k1))
             {
                 final int metadata;
-                if (Block.getBlock(plantBlockId) instanceof BlockFlowerStackable) {
+                if (Blocks.getBlock(plantBlockId) instanceof BlockFlowerStackable) {
                     final int stackSize;
                     if (varyStackSize) {
                         stackSize = getStackSize(random);
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java
similarity index 97%
rename from src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java
rename to game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java
index fd80e4a6d..746ed8185 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLake.java
@@ -19,7 +19,7 @@ public class WorldFeatureLake extends WorldFeature
     @Override
 	public boolean place(World world, Random random, int x, int y, int z)
     {
-//    	Block liquid = Block.blocksList[liquidId];
+//    	Block liquid = Blocks.blocksList[liquidId];
 //    	Biome biome = world.getBlockBiome(x, y, z);
 
         x -= 8;
@@ -119,7 +119,7 @@ public class WorldFeatureLake extends WorldFeature
 
         }
 
-        if(Block.blocksList[liquidId].blockMaterial == Material.lava)
+        if(Blocks.blocksList[liquidId].blockMaterial == Material.lava)
         {
             for(int dx = 0; dx < 16; dx++)
             {
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLiquid.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLiquid.java
similarity index 95%
rename from src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLiquid.java
rename to game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLiquid.java
index 5f26b11d4..a19c45dfe 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLiquid.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLiquid.java
@@ -67,7 +67,7 @@ public class WorldFeatureLiquid extends WorldFeature
         {
             world.setBlockWithNotify(x, y, z, liquidBlockId);
             world.scheduledUpdatesAreImmediate = true;
-            Block.blocksList[liquidBlockId].updateTick(world, x, y, z, random);
+            Blocks.blocksList[liquidBlockId].updateTick(world, x, y, z, random);
             world.scheduledUpdatesAreImmediate = false;
         }
         return true;
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMeadow.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMeadow.java
similarity index 85%
rename from src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMeadow.java
rename to game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMeadow.java
index 312d3c7df..dc8d1fe4f 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMeadow.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureMeadow.java
@@ -3,6 +3,7 @@ package net.minecraft.core.world.generate.feature;
 import net.minecraft.core.block.BlockLeavesBase;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockFlowerStackable;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
@@ -18,7 +19,7 @@ public class WorldFeatureMeadow extends WorldFeature
     @Override
     public boolean place(World world, Random random, int x, int y, int z)
     {
-        for(int l; ((l = world.getBlockId(x, y, z)) == 0 || Block.blocksList[l] instanceof BlockLeavesBase) && y > 0; y--) { }
+        for(int l; ((l = world.getBlockId(x, y, z)) == 0 || Blocks.blocksList[l] instanceof BlockLeavesBase) && y > 0; y--) { }
         for(int i1 = 0; i1 < 128; i1++)
         {
             int j1 = (x + random.nextInt(8)) - random.nextInt(8);
@@ -29,7 +30,7 @@ public class WorldFeatureMeadow extends WorldFeature
             int index = random.nextInt(blockIds.length);
             int flowerId = blockIds[index];
 
-            if(world.isAirBlock(j1, k1, l1) && Block.blocksList[flowerId].canBlockStay(world, j1, k1, l1))
+            if(world.isAirBlock(j1, k1, l1) && Blocks.blocksList[flowerId].canBlockStay(world, j1, k1, l1))
             {
                 final int meta = BlockFlowerStackable.setStackCount(0, WorldFeatureFlowers.getStackSize(random));
                 world.setBlockAndMetadata(j1, k1, l1, flowerId, meta);
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherLava.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherLava.java
similarity index 96%
rename from src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherLava.java
rename to game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherLava.java
index 768152aab..cca2f0297 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherLava.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureNetherLava.java
@@ -72,7 +72,7 @@ public class WorldFeatureNetherLava extends WorldFeature
         {
             world.setBlockWithNotify(x, y, z, blockId);
             world.scheduledUpdatesAreImmediate = true;
-            Block.blocksList[blockId].updateTick(world, x, y, z, random);
+            Blocks.blocksList[blockId].updateTick(world, x, y, z, random);
             world.scheduledUpdatesAreImmediate = false;
         }
         return true;
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSpinifexPatch.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSpinifexPatch.java
similarity index 93%
rename from src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSpinifexPatch.java
rename to game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSpinifexPatch.java
index e0cb29cae..7cfb9f89d 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSpinifexPatch.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureSpinifexPatch.java
@@ -12,7 +12,7 @@ public class WorldFeatureSpinifexPatch extends WorldFeature
     @Override
     public boolean place(World world, Random random, int x, int y, int z)
     {
-        for(int l; ((l = world.getBlockId(x, y, z)) == 0 || Block.blocksList[l] instanceof BlockLeavesBase) && y > 0; y--) { }
+        for(int l; ((l = world.getBlockId(x, y, z)) == 0 || Blocks.blocksList[l] instanceof BlockLeavesBase) && y > 0; y--) { }
         for(int i1 = 0; i1 < 64; i1++)
         {
             int j1 = (x + random.nextInt(4)) - random.nextInt(4);
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureTallGrass.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureTallGrass.java
similarity index 78%
rename from src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureTallGrass.java
rename to game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureTallGrass.java
index e6fda6c8f..f7295c918 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureTallGrass.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureTallGrass.java
@@ -2,6 +2,7 @@ package net.minecraft.core.world.generate.feature;
 
 import net.minecraft.core.block.BlockLeavesBase;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 
 import java.util.Random;
@@ -19,7 +20,7 @@ public class WorldFeatureTallGrass extends WorldFeature
 	public boolean place(World world, Random random, int x, int y, int z)
     {
         int l;
-        while (((l = world.getBlockId(x, y, z)) == 0 || Block.blocksList[l] instanceof BlockLeavesBase) && y > 0) {
+        while (((l = world.getBlockId(x, y, z)) == 0 || Blocks.blocksList[l] instanceof BlockLeavesBase) && y > 0) {
             y--;
         }
         for(int i1 = 0; i1 < 128; i1++)
@@ -30,7 +31,7 @@ public class WorldFeatureTallGrass extends WorldFeature
 
             int meta = 0;
 
-            if(world.isAirBlock(j1, k1, l1) && Block.blocksList[blockId].canBlockStay(world, j1, k1, l1))
+            if(world.isAirBlock(j1, k1, l1) && Blocks.blocksList[blockId].canBlockStay(world, j1, k1, l1))
             {
                 world.setBlockAndMetadata(j1, k1, l1, blockId, meta);
             }
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java
similarity index 99%
rename from src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java
rename to game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java
index 0a9ac8c46..c19e11a01 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/WorldFeatureTreePalm.java
@@ -176,7 +176,7 @@ public class WorldFeatureTreePalm extends WorldFeature {
 		if(id == 0) {
 			return true;
 		}
-		Block block = Block.getBlock(id);
+		Block block = Blocks.getBlock(id);
 		
 		// TODO Create BlockTag and apply to all trees
 		if(block instanceof BlockLog) {
diff --git a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java
similarity index 97%
rename from src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java
rename to game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java
index 404504338..248b36af7 100644
--- a/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/tree/spooner/WorldFeatureSpoonerTree.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.generate.feature.tree.spooner;
 
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.MethodParametersAnnotation;
@@ -100,7 +101,7 @@ public abstract class WorldFeatureSpoonerTree
         int interruptedTrunkHeight = -1;
         int y = pos[1];
         while (y < world.getHeightBlocks()) {
-            if (Block.solid[world.getBlockId(pos[0], y, pos[2])]) {
+            if (Blocks.solid[world.getBlockId(pos[0], y, pos[2])]) {
                 interruptedTrunkHeight = y - pos[1];
                 break;
             }
diff --git a/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java b/game/core/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java
similarity index 97%
rename from src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java
rename to game/core/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java
index 5b6fa2c05..fb8d14baf 100644
--- a/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java
+++ b/game/core/src/main/java/net/minecraft/core/world/pathfinder/PathFinder.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.pathfinder;
 
 import net.minecraft.core.block.BlockDoor;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.material.Material;
@@ -191,7 +192,7 @@ public class PathFinder
                     {
                         continue;
                     }
-                    if(Block.blocksList[k1] instanceof BlockDoor)
+                    if(Blocks.blocksList[k1] instanceof BlockDoor)
                     {
                         int l1 = worldSource.getBlockMetadata(x1, y1, z1);
                         if(!BlockDoor.isOpen(l1))
@@ -200,7 +201,7 @@ public class PathFinder
                         }
                         continue;
                     }
-                    Material material = Block.blocksList[k1].blockMaterial;
+                    Material material = Blocks.blocksList[k1].blockMaterial;
                     if(material.blocksMotion())
                     {
                         return 0;
diff --git a/game/server/.gitignore b/game/server/.gitignore
new file mode 100644
index 000000000..8219306d0
--- /dev/null
+++ b/game/server/.gitignore
@@ -0,0 +1,3 @@
+build
+mp
+logs
\ No newline at end of file
diff --git a/game/server/build.gradle.kts b/game/server/build.gradle.kts
new file mode 100644
index 000000000..c16e586bb
--- /dev/null
+++ b/game/server/build.gradle.kts
@@ -0,0 +1,74 @@
+import com.github.jengelman.gradle.plugins.shadow.tasks.ShadowJar
+import com.github.jengelman.gradle.plugins.shadow.transformers.Log4j2PluginsCacheFileTransformer
+
+plugins {
+    id("java")
+    alias(libs.plugins.shadow)
+}
+
+group = providers.gradleProperty("bta.group").get()
+version = providers.gradleProperty("bta.version").get()
+
+val include: Configuration by configurations.creating
+
+repositories {
+    mavenCentral()
+    maven("https://libraries.minecraft.net/")
+}
+
+dependencies {
+    implementation(project(":game:core"))?.let { include(it) }
+    runtimeOnly(project(path = ":util:datagen", configuration = "output"))?.let { include(it) }
+
+    // <core dependencies>
+    implementation(libs.jetbrains.annotations)?.let { include(it) }
+    implementation(libs.gson)?.let { include(it) }
+    implementation(libs.brigadier)?.let { include(it) }
+    implementation(libs.bundles.log4j)?.let { include(it) }
+    // </core dependencies>
+}
+
+java {
+    sourceCompatibility = JavaVersion.VERSION_1_8
+    targetCompatibility = JavaVersion.VERSION_1_8
+}
+
+//region Tasks
+val run by tasks.registering(JavaExec::class) {
+    group = "bta"
+
+    File(workingDir, "mp").let {
+        it.mkdirs()
+        workingDir = it
+    }
+
+    mainClass.set("net.minecraft.server.MinecraftServer")
+    classpath += sourceSets["main"].runtimeClasspath
+    jvmArgs = listOf("-ea")
+}
+
+val buildJar by tasks.registering(ShadowJar::class) {
+    group = "bta"
+    configurations = listOf(include)
+
+    from(sourceSets.main.get().output.classesDirs)
+    from(sourceSets.main.get().resources)
+    exclude("fabric.mod.json")
+
+    archiveFileName = "bta-server.jar"
+    transform(Log4j2PluginsCacheFileTransformer::class.java)
+    manifest {
+        attributes["Main-Class"] = "net.minecraft.server.MinecraftServer"
+        attributes["Implementation-Version"] = version
+    }
+}
+
+tasks.withType(JavaCompile::class.java) {
+    options.isIncremental = false
+    options.encoding = "UTF-8"
+    if (JavaVersion.current() != JavaVersion.VERSION_1_8) {
+        options.compilerArgs.add("--release")
+        options.compilerArgs.add("8")
+    }
+}
+//endregion
diff --git a/src/main/java/net/minecraft/server/MinecraftServer.java b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
similarity index 99%
rename from src/main/java/net/minecraft/server/MinecraftServer.java
rename to game/server/src/main/java/net/minecraft/server/MinecraftServer.java
index 7a314abed..f2359f95d 100644
--- a/src/main/java/net/minecraft/server/MinecraftServer.java
+++ b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
@@ -53,7 +53,7 @@ import net.minecraft.core.net.command.commands.CommandWeather;
 import net.minecraft.core.net.command.util.CommandHelper;
 import net.minecraft.server.entity.player.PlayerServer;
 import net.minecraft.server.net.command.ConsoleCommandSource;
-import net.minecraft.core.net.packet.SetTimePacket;
+import net.minecraft.core.net.packet.PacketSetTime;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.sound.SoundTypes;
 import net.minecraft.core.util.helper.RSA;
@@ -750,7 +750,7 @@ public class MinecraftServer
             }
             if (deathTime % 20 == 0)
             {
-                playerList.sendPacketToAllPlayersInDimension(new SetTimePacket(worldServer.getWorldTime()), worldServer.dimension.id);
+                playerList.sendPacketToAllPlayersInDimension(new PacketSetTime(worldServer.getWorldTime()), worldServer.dimension.id);
             }
             try {
                 worldServer.tick();
diff --git a/src/main/java/net/minecraft/server/entity/EntityTrackerEntryImpl.java b/game/server/src/main/java/net/minecraft/server/entity/EntityTrackerEntryImpl.java
similarity index 84%
rename from src/main/java/net/minecraft/server/entity/EntityTrackerEntryImpl.java
rename to game/server/src/main/java/net/minecraft/server/entity/EntityTrackerEntryImpl.java
index 476ad3ab7..026f4632c 100644
--- a/src/main/java/net/minecraft/server/entity/EntityTrackerEntryImpl.java
+++ b/game/server/src/main/java/net/minecraft/server/entity/EntityTrackerEntryImpl.java
@@ -6,16 +6,16 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.entity.EntityTrackerEntry;
 import net.minecraft.core.net.entity.NetEntityHandler;
-import net.minecraft.core.net.packet.MoveEntityPacket;
+import net.minecraft.core.net.packet.PacketMoveEntity;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.SleepPacket;
-import net.minecraft.core.net.packet.SetEntityMotionPacket;
-import net.minecraft.core.net.packet.RemoveEntityPacket;
-import net.minecraft.core.net.packet.TeleportEntityPacket;
-import net.minecraft.core.net.packet.EntityNicknamePacket;
-import net.minecraft.core.net.packet.SetEntityDataPacket;
-import net.minecraft.core.net.packet.EntityTagDataPacket;
-import net.minecraft.core.net.packet.SetEquippedItemPacket;
+import net.minecraft.core.net.packet.PacketSleep;
+import net.minecraft.core.net.packet.PacketSetEntityMotion;
+import net.minecraft.core.net.packet.PacketRemoveEntity;
+import net.minecraft.core.net.packet.PacketTeleportEntity;
+import net.minecraft.core.net.packet.PacketEntityNickname;
+import net.minecraft.core.net.packet.PacketSetEntityData;
+import net.minecraft.core.net.packet.PacketEntityTagData;
+import net.minecraft.core.net.packet.PacketSetEquippedItem;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.data.SynchedEntityData;
 import net.minecraft.server.entity.player.PlayerServer;
@@ -102,13 +102,13 @@ public class EntityTrackerEntryImpl implements EntityTrackerEntry {
                 trackedEntity.x = (double)entityX / 32D;
                 trackedEntity.y = (double)entityY / 32D;
                 trackedEntity.z = (double)entityZ / 32D;
-                packet = new TeleportEntityPacket(trackedEntity.id, entityX, entityY, entityZ, (byte)entityYaw, (byte)entityPitch);
+                packet = new PacketTeleportEntity(trackedEntity.id, entityX, entityY, entityZ, (byte)entityYaw, (byte)entityPitch);
             } else if(hasMoved && hasLooked) {
-                packet = new MoveEntityPacket.PosRot(trackedEntity.id, (byte)dx, (byte)dy, (byte)dz, (byte)entityYaw, (byte)entityPitch);
+                packet = new PacketMoveEntity.PosRot(trackedEntity.id, (byte)dx, (byte)dy, (byte)dz, (byte)entityYaw, (byte)entityPitch);
             } else if(hasMoved) {
-                packet = new MoveEntityPacket.Pos(trackedEntity.id, (byte)dx, (byte)dy, (byte)dz);
+                packet = new PacketMoveEntity.Pos(trackedEntity.id, (byte)dx, (byte)dy, (byte)dz);
             } else if(hasLooked) {
-                packet = new MoveEntityPacket.Rot(trackedEntity.id, (byte)entityYaw, (byte)entityPitch);
+                packet = new PacketMoveEntity.Rot(trackedEntity.id, (byte)entityYaw, (byte)entityPitch);
             }
             if(shouldSendMotionUpdates) {
                 double d = trackedEntity.xd - lastTrackedEntityMotionX;
@@ -120,7 +120,7 @@ public class EntityTrackerEntryImpl implements EntityTrackerEntry {
                     lastTrackedEntityMotionX = trackedEntity.xd;
                     lastTrackedEntityMotionY = trackedEntity.yd;
                     lastTrackedEntityMotionZ = trackedEntity.zd;
-                    sendPacketToTrackedPlayers(new SetEntityMotionPacket(trackedEntity.id, lastTrackedEntityMotionX, lastTrackedEntityMotionY, lastTrackedEntityMotionZ));
+                    sendPacketToTrackedPlayers(new PacketSetEntityMotion(trackedEntity.id, lastTrackedEntityMotionX, lastTrackedEntityMotionY, lastTrackedEntityMotionZ));
                 }
             }
             if(packet != null) {
@@ -128,7 +128,7 @@ public class EntityTrackerEntryImpl implements EntityTrackerEntry {
             }
             SynchedEntityData synchedEntityData = trackedEntity.getEntityData();
             if(synchedEntityData.isDirty()) {
-                sendPacketToTrackedPlayersAndTrackedEntity(new SetEntityDataPacket(trackedEntity.id, synchedEntityData));
+                sendPacketToTrackedPlayersAndTrackedEntity(new PacketSetEntityData(trackedEntity.id, synchedEntityData));
             }
             if(hasMoved) {
                 encodedPosX = entityX;
@@ -141,11 +141,11 @@ public class EntityTrackerEntryImpl implements EntityTrackerEntry {
             }
         }
         if(trackedEntity.hurtMarked) {
-            sendPacketToTrackedPlayersAndTrackedEntity(new SetEntityMotionPacket(trackedEntity));
+            sendPacketToTrackedPlayersAndTrackedEntity(new PacketSetEntityMotion(trackedEntity));
             trackedEntity.hurtMarked = false;
         }
         if (trackedEntity.hadNicknameSet) {
-            sendPacketToTrackedPlayersAndTrackedEntity(new EntityNicknamePacket(trackedEntity.id, ((Mob) trackedEntity).nickname, ((Mob) trackedEntity).chatColor));
+            sendPacketToTrackedPlayersAndTrackedEntity(new PacketEntityNickname(trackedEntity.id, ((Mob) trackedEntity).nickname, ((Mob) trackedEntity).chatColor));
             trackedEntity.hadNicknameSet = false;
         }
     }
@@ -164,7 +164,7 @@ public class EntityTrackerEntryImpl implements EntityTrackerEntry {
     }
 
     public void sendDestroyEntityPacketToTrackedPlayers() {
-        sendPacketToTrackedPlayers(new RemoveEntityPacket(trackedEntity.id));
+        sendPacketToTrackedPlayers(new PacketRemoveEntity(trackedEntity.id));
     }
 
     public void removeFromTrackedPlayers(Player player) {
@@ -184,28 +184,28 @@ public class EntityTrackerEntryImpl implements EntityTrackerEntry {
                 trackedPlayers.add(playerServer);
                 playerServer.playerNetServerHandler.sendPacket(NetEntityHandler.getSpawnPacket(this));
                 if (trackedEntity.sendAdditionalData) {
-                    playerServer.playerNetServerHandler.sendPacket(new EntityTagDataPacket(trackedEntity));
+                    playerServer.playerNetServerHandler.sendPacket(new PacketEntityTagData(trackedEntity));
                 }
                 if(shouldSendMotionUpdates) {
-                    playerServer.playerNetServerHandler.sendPacket(new SetEntityMotionPacket(trackedEntity.id, trackedEntity.xd, trackedEntity.yd, trackedEntity.zd));
+                    playerServer.playerNetServerHandler.sendPacket(new PacketSetEntityMotion(trackedEntity.id, trackedEntity.xd, trackedEntity.yd, trackedEntity.zd));
                 }
                 ItemStack[] aitemstack = trackedEntity.getInventory();
                 if(aitemstack != null) {
                     for(int i = 0; i < aitemstack.length; i++) {
-                        playerServer.playerNetServerHandler.sendPacket(new SetEquippedItemPacket(trackedEntity.id, i, aitemstack[i]));
+                        playerServer.playerNetServerHandler.sendPacket(new PacketSetEquippedItem(trackedEntity.id, i, aitemstack[i]));
                     }
                 }
                 if(trackedEntity instanceof PlayerServer) {
                     PlayerServer trackedPlayerServer = (PlayerServer) trackedEntity;
                     if(trackedPlayerServer.isPlayerSleeping())
                     {
-                        playerServer.playerNetServerHandler.sendPacket(new SleepPacket(trackedEntity, 0, MathHelper.floor(trackedEntity.x), MathHelper.floor(trackedEntity.y), MathHelper.floor(trackedEntity.z)));
+                        playerServer.playerNetServerHandler.sendPacket(new PacketSleep(trackedEntity, 0, MathHelper.floor(trackedEntity.x), MathHelper.floor(trackedEntity.y), MathHelper.floor(trackedEntity.z)));
                     }
                 }
             }
         } else if(trackedPlayers.contains(playerServer)) {
             trackedPlayers.remove(playerServer);
-            playerServer.playerNetServerHandler.sendPacket(new RemoveEntityPacket(trackedEntity.id));
+            playerServer.playerNetServerHandler.sendPacket(new PacketRemoveEntity(trackedEntity.id));
         }
     }
 
@@ -219,7 +219,7 @@ public class EntityTrackerEntryImpl implements EntityTrackerEntry {
             PlayerServer playerServer = (PlayerServer) player;
             if(trackedPlayers.contains(playerServer)) {
                 trackedPlayers.remove(playerServer);
-                playerServer.playerNetServerHandler.sendPacket(new RemoveEntityPacket(trackedEntity.id));
+                playerServer.playerNetServerHandler.sendPacket(new PacketRemoveEntity(trackedEntity.id));
             }
         }
     }
diff --git a/src/main/java/net/minecraft/server/entity/ServerSkinVariantList.java b/game/server/src/main/java/net/minecraft/server/entity/ServerSkinVariantList.java
similarity index 75%
rename from src/main/java/net/minecraft/server/entity/ServerSkinVariantList.java
rename to game/server/src/main/java/net/minecraft/server/entity/ServerSkinVariantList.java
index 4c79c58aa..cd1812c8b 100644
--- a/src/main/java/net/minecraft/server/entity/ServerSkinVariantList.java
+++ b/game/server/src/main/java/net/minecraft/server/entity/ServerSkinVariantList.java
@@ -9,4 +9,9 @@ public class ServerSkinVariantList extends SkinVariantList {
     public @NotNull String getSkinReference(@Nullable String variantJsonPath, @NotNull String defaultKey, int skinIndex) {
         return "";
     }
+
+    @Override
+    public int nextSkinVariant(@Nullable String variantJsonPath, int skinIndex) {
+        return skinIndex;
+    }
 }
